/*
    Very Simple Code Generator for Intel x86
    Register Version
	$Id: s-code-intel-r.c,v 1.1 1999/12/11 12:44:15 kono Exp kono $
 */

#include "s-compile.h"

int  label = 0;
char *comments = "#####";


char *intro[] = {
    "#APP\n",    /* To process comments by GNU as */
    "\t.file   \"s-calc.c\"\n",
    ".text\n",
    "\t.align 2\n",
    ".globl main\nmain:\n",
    "\tpushl %ebp\n",
    "\tmovl %esp,%ebp\n",
    "\tsubl $1028,%esp\n",
/*
#ifndef NEXTSTEP
    "\tcall ___main\n",
#endif
 */
    NULL
};

char *ending[] = {
    "\txorl %eax,%eax\n",
    "\tleave\n",
    "\tret\n",
    "_print:\n",
    "\tpushl %ebp\n",
    "\tmovl %esp,%ebp\n",
    "\tpushl %eax\n",
    "\tpushl $_format\n",
    "\tcall printf\n",
    "\tleave\n",
    "\tret\n",
    "_format:\n",
    "\t.ascii \" = %d\\12\\0\"\n",
    "\t.align 2\n",
    ".comm _variable,192\n",
    NULL
};


static int  creg;     /* current register */
static char *crn;     /* current register name */
static int  lreg;     /* operand register */
static char *lrn;     /* operand register name */
static int  dreg;     /* temporary register */
static char *drn;     /* temporary register name */
static int  xreg;     /* operand register  */
static char *xrn;     /* operand register name */
static int  reg_sp;   /* REGister Stack-Pointer */


#define REG_EAX   0
#define REG_EBX   1
#define REG_ECX   2
#define REG_EDX   3
#define REG_ESI   4
#define REG_EDI   5
#define REG_EBP   6
#define REG_ESP   7


#define DATA_REG 0    
#define POINTER_REG 3    

/*
    creg   currrent register
    lreg   operand  register
    dreg   spare    register

    regs[]          register usage

    reg_name[creg]  register name
 */

#define MAX_MAX 20
static int regs[MAX_MAX];       /* ȤƤ쥸򼨤ե饰 */
static int reg_stack[MAX_MAX];  /* ºݤΥ쥸ΰ */

int	MAX_REGISTER=6;
int	MAX_DATA_REG=4;    
int	MAX_POINTER=3;    
static char    *reg_name[] = {"%eax","%ebx","%ecx","%edx","%esi",
		      "%edi","%ebp","%esp"};
static char    *reg_name_l[] = {"%al","%bl","%cl","%dl"};

char *
regster(i)
int i;
{
    return reg_name[i];
}

int 
get_register() 
{    /* ȤƤʤ쥸Ĵ٤ */
    int i;
    for(i=0;i<MAX_REGISTER;i++) {
	if (! regs[i]) {    /* ȤƤʤʤ */
	    regs[i]=1;      /* Υ쥸ȤȤ */
	    return i;       /* ξɽֹ֤ */
	}
    }
    return -1;    /* Ƥ꤬ʤʤ顢ɽ -1 ֤ */
}

void 
free_register(i) {    /* ʤʤä쥸 */
    regs[i]=0;
}

int
register_full()
{
    int i;
    for(i=0;i<MAX_REGISTER;i++) {
	if (! regs[i]) { 
	    return 0;  
	}
    }
    return 1;    
}

void 
emit_init() 
{
    int i;
    for(i=0;i<MAX_REGISTER;i++) regs[i]=0;
    creg = get_register();
    crn = reg_name[creg];
    dreg = REG_EDX; /* ϳ任ʤɤ̤˻Ȥ */
    regs[dreg]=1;
    drn = reg_name[dreg];
    reg_sp = 0;
}

int 
pop_register() 
{     /* 쥸ͤФ */
    int i,j;

    j = creg;
    i = reg_stack[--reg_sp];

    if(i<0) {
	return i;
    } else {
	lreg = i;
	lrn = reg_name[lreg];
	regs[i]=0;
	return lreg;
    }
}

void 
emit_push()
{
    int new_reg;
    new_reg = get_register();
    if(new_reg<0) {                     /* ⤦쥸ʤ */
	if (reg_sp==MAX_MAX-1) {
	    printf("Compilation error: too complex expression\n");
	} else {
	    reg_stack[reg_sp++] =  -1;
	    printf("\tpushl %s\n",crn);
	}
    } else {
	reg_stack[reg_sp++] = creg;     /* push 뤫˥쥸Ȥ */
	creg = new_reg;
	crn = reg_name[creg];
    }
}

char *
emit_pop()
{
    if (pop_register()==-1) {
	printf("\tpopl %s\n",drn);
	xrn = drn;
	xreg = dreg;
    } else {
	xrn = lrn;
	xreg = lreg;
    }
    return xrn;
}


void
emit_compare() 
{
    char *orn;
    orn = emit_pop();
    printf("\tcmpl %s,%s\n",crn,orn);
    printf("\t%s %%dl\n","setg");
    printf("\tmovzbl %%dl,%s\n",crn);
}

void
emit_store(assign)
int assign;
{
    printf("\tmovl %s,_variable+%d\n",crn,assign*4);
}


char *opcode[] = {
    "",
    "subl",
    "addl",
    "imull",
    "idiv",
    "",
    "",
    "",
    "",
    "subl",
    "idiv",
};

void
emit_calc(op)
int op;
{
    char *orn;
    orn = emit_pop();
    if(op==O_DIV) {
	if (xreg==REG_EAX) {
	    printf("\tcltd\n");
	    printf("\tdivl %s\n",crn);
	    printf("\tmovl %s,%s\n",xrn,crn);
	} else if (creg==REG_EAX) {
	    printf("\txchg %s,%s\n",xrn,crn);
	    printf("\tcltd\n");
	    printf("\tdivl %s\n",xrn);
	} else {
	    if (regs[REG_EAX]) {
		printf("\tpushl %%eax\n");
	    }
	    printf("\tmovl %s,%%eax\n",xrn);
	    printf("\tcltd\n");
	    printf("\tdivl %s\n",crn);
	    printf("\tmovl %%eax,%s\n",crn);
	    if (regs[REG_EAX]) {
		printf("\tpopl %%eax\n");
	    }
	}
    } else {
	printf("\t%s %s,%s\n",opcode[op],orn,crn);
    }
}

void
emit_value(d) 
int d;
{
    printf("\tmovl $%d,%s\n",d,crn);
}

void
emit_load(d)
int d;
{
    printf("\tmovl _variable+%d,%s\n",d*4,crn);
}

void
emit_comment()
{
    if (before < ptr) {
	putchar('#'); putchar('#'); putchar(' ');
	while (before < ptr) {
	    if(*before && *before!='\n') {
		putchar(*before);
	    }
	    before++;
	}
	putchar('\n');
    }
}

void
emit_print()
{
    if (creg!=REG_EAX) {
        printf("\tmovl %s,%%eax\n",crn);
    }
    printf("\tcall _print\n");
}


void
emit_intro()
{
    char **iptr;
    for(iptr=intro;*iptr;iptr++) {
        printf("%s",*iptr);
    }
    emit_init() ;
}

void
emit_ending()
{
    char **iptr;
    for(iptr=ending;*iptr;iptr++) {
        printf("%s",*iptr);
    }
}

/* end */
